package nl.amis.html5.view;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

import java.net.MalformedURLException;
import java.net.URL;

import java.util.ArrayList;
import java.util.List;

import javax.faces.component.UIComponent;
import javax.faces.event.ActionEvent;

import oracle.adf.view.rich.context.AdfFacesContext;
import oracle.adf.view.rich.render.ClientEvent;

import view.Location;

public class LocationBean {

    List<Location> locations = new ArrayList<Location>();
    UIComponent map ;

    public void locationAbsorber(ClientEvent event) {
        Double latitude = (Double)event.getParameters().get("latitude");
        ;
        Double longitude = (Double)event.getParameters().get("longitude");
        System.out.println("---" + longitude+" , "+latitude);
        addCurrentLocation(longitude, latitude);
        
    }
    public void setLocations(List locations) {
        this.locations = locations;
    }

    public List getLocations() {
        return locations;
    }

    public void addLocation(Location loc) {
        locations.add(loc);
    }
    public void addCurrentLocation(Double longitude, Double latitude) {
        Location loc = new Location();
        loc.setLabel( "Your Current Location");
        loc.setCountry("NLD");
        loc.setDescription("location made available through browser and HTML5 Navigator API");
        loc.setDescription(getHumanReadableAddressForGeoLocation(longitude.floatValue(), latitude.floatValue()));
        loc.setCoordinates(new float[] {latitude.floatValue(), longitude.floatValue()});
        locations.add(loc);
        AdfFacesContext adfFacesCtx = AdfFacesContext.getCurrentInstance();
             // PPR
             adfFacesCtx.addPartialTarget(map);
             
    }


    private String getHumanReadableAddressForGeoLocation(float longitude, float latitude) {
        URL geoCodeUrl;
        String url= "http://maps.googleapis.com/maps/api/geocode/json?latlng=" + Float.toString(latitude)+","+Float.toString(longitude) +
                            "&oe=utf8&sensor=false";
        try {
            geoCodeUrl =
                
          
                    new URL(url);
        } catch (MalformedURLException e) {
            System.out.println(e.getMessage()+" url="+url);
            return null;
        }
        BufferedReader in;
        String coord = null;
        try {

            in = new BufferedReader(new InputStreamReader(geoCodeUrl.openStream()));
            char[] buf = new char[8000];
            
            in.read(buf);
            coord = new StringBuilder().append(buf).toString();
                
            in.close();
        } catch (IOException e) {
            System.out.println(e.getMessage()+" IO Exception ");
            return null;
        }
        if (coord != null) {

          float[] coordinates ;
         try{
             // find first occurrence of formatted_address
              int posFA = coord.indexOf("\"formatted_address\"");
              String latString = coord.substring(posFA+41,posFA+68);
              
            return latString;
          }catch (Exception e) {System.out.println("Coordinates stank "+coord);}
        }
        System.out.println("Failed to create proper coordinates; sorry!");
        return null;
    }


    public void setMap(UIComponent map) {
        this.map = map;
    }

    public UIComponent getMap() {
        return map;
    }
}
