package view;

    import java.net.URL;
    import java.io.BufferedReader;
    import java.io.IOException;
    import java.io.InputStreamReader;

    import java.net.MalformedURLException;



    public class Location {

        private String location;
        private String country;
        private String label;
        private String description;
        private float[] coordinates;
        
        private static float[] getCoordinatesForLocation(String location) {
            URL geoCodeUrl;
            String url= "http://maps.googleapis.com/maps/api/geocode/json?address=" + location +
                                "&oe=utf8&sensor=false";
            try {
                geoCodeUrl =
                    
              
                        new URL(url);
            } catch (MalformedURLException e) {
                System.out.println(e.getMessage()+" url="+url);
                return null;
            }
            BufferedReader in;
            String coord = null;
            try {

                in = new BufferedReader(new InputStreamReader(geoCodeUrl.openStream()));
                char[] buf = new char[8000];
                
                in.read(buf);
                coord = new StringBuilder().append(buf).toString();
                    
                in.close();
            } catch (IOException e) {
                System.out.println(e.getMessage()+" IO Exception ");
                return null;
            }
            if (coord != null) {
              float[] coordinates ;
              try{
                  // find first occurrence of lat
                  int posLAT = coord.indexOf("\"lat\"");
                  String latString = coord.substring(posLAT,posLAT+21);
                  
                  String lat = latString.split(":")[1].replaceAll(" ", "").replaceAll(",", "");
                  // find first occurrence of lng
                  int posLNG = coord.indexOf("\"lng\"");              
                  String lngString = coord.substring(posLNG,posLNG+21);
                String lng = lngString.split(":")[1].replaceAll(" ", "").replaceAll(",", "");

                coordinates =
                    new float[] { Float.parseFloat(lat), Float.parseFloat(lng) };
                return coordinates;
              }catch (Exception e) {System.out.println("Coordinates stank "+coord);}
            }
            System.out.println("Failed to create proper coordinates; sorry!");
            return null;
        }

        public void setLocation(String location) {
            this.location = location;
        }

        public String getLocation() {
            return location;
        }

        public void setCountry(String country) {
            this.country = country;
        }

        public String getCountry() {
            return country;
        }

        public void setLabel(String label) {
            this.label = label;
        }

        public String getLabel() {
            return label;
        }

        public void setCoordinates(float[] coordinates) {
            this.coordinates = coordinates;
        }

        public float[] getCoordinates() {
            if (coordinates == null) {
                coordinates = getCoordinatesForLocation(location);
            }
            return coordinates;
        }
        
        public float getLongitude() {
            return getCoordinates()[0];
        }
        public float getLattitude() {
            return getCoordinates()[1];
        }

    public void setDescription(String description) {
        this.description = description;
    }

    public String getDescription() {
        return description;
    }
}
