package view;

import java.util.ArrayList;
import java.util.List;

import javax.faces.bean.ManagedBean;
import javax.faces.bean.ManagedProperty;
import javax.faces.bean.SessionScoped;
import javax.faces.event.ActionEvent;

@ManagedBean(name="locationsCollector")
@SessionScoped
public class LocationsCollector {

    List<Location> locations = new ArrayList<Location>();
    @ManagedProperty(name = "currentLocation",value="#{currentLocation}")
    Location currentLocation;

    public LocationsCollector() {
        Location loc = new Location();
        loc.setCountry("The+Netherlands");
        loc.setLabel("Zoetermeer");
        loc.setLocation("Zoetermeer");
        loc.setDescription("Home Sweet(lake) Home");
        locations.add(loc);
    }


    public void setLocations(List locations) {
        this.locations = locations;
    }

    public List getLocations() {
        return locations;
    }

    public void addLocation(Location loc) {
        locations.add(loc);
    }
    public void addCurrentLocation(ActionEvent ae) {
        Location loc = new Location();
        loc.setLabel( currentLocation.getLabel());
        loc.setCountry(currentLocation.getCountry());
        loc.setDescription(currentLocation.getDescription());
        loc.setLocation(currentLocation.getLocation()+"+"+currentLocation.getCountry());
        locations.add(loc);

    }

    public void removeLocation(Location loc) {
        locations.remove(loc);
    }

    public void setCurrentLocation(Location currentLocation) {
        this.currentLocation = currentLocation;
    }

    public Location getCurrentLocation() {
        return currentLocation;
    }
}
